#include <avr/io.h>

#include "leds.h"

static uint8_t oleds;

static void leds_set( uint8_t v ) {
     
     if (oleds == v)
	  return;

     // LED0
     PORTB &= ~_BV( PB1 );
     if (v & 1)
	  PORTB |= _BV( PB1 );
     
     // LED1
     PORTD &= ~_BV( PD7 );
     if (v & 2)
	  PORTD |= _BV( PD7 );
     
     // LED2..6
     PORTC &= 0x83;
     PORTC |= (v & 0x7c);
     
     leds_value = v;
     oleds      = v;
}

void leds_init( void ) {
     DDRB |= _BV( PB1 ); // LED0
     DDRD |= _BV( PD7 ); // LED1
     DDRC |= 0x7c; // PC2..6

     oleds = 1;
     leds_set( _BV(6) ); // red LED on
}

void leds_periodic( void ) {

     leds_set( leds_value );

}


